Bug 40463 - piped logging causes some weird kill()ing
Summary: piped logging causes some weird kill()ing
Status: RESOLVED LATER
Alias: None
Product: Apache httpd-2
Classification: Unclassified
Component: mod_log_config (show other bugs)
Version: 2.2.2
Hardware: Other other
: P2 normal (vote)
Target Milestone: ---
Assignee: Apache HTTPD Bugs Mailing List
URL:
Keywords: MassUpdate
Depends on:
Blocks:
 
Reported: 2006-09-11 10:04 UTC by Arkadiusz Miskiewicz
Modified: 2018-11-07 21:09 UTC (History)
0 users



Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Arkadiusz Miskiewicz 2006-09-11 10:04:23 UTC
The problem looks like this:

[root@web2 ~]# service httpd restart
httpd.prefork service is not running.
Starting httpd.prefork service.....................................[ BUSY
 ]Terminated
Terminated
Terminated

stracing shows for 2.0.59 and 2.2.3:

2.0.59
 
[root@pepe ~]# grep 'kill(' WYNIK
28181 kill(28180, SIGTERM)              = 0
 
 
2.2.3
[root@pepe buildmpm-prefork]# grep 'kill(' WYNIK
31818 kill(31818, SIGCHLD <unfinished ...>
31818 kill(31818, SIGCHLD <unfinished ...>
31855 kill(31854, SIGTERM)              = 0
31854 kill(0, SIGTERM <unfinished ...>
31818 kill(0, SIGTERM <unfinished ...>
31810 kill(0, SIGTERM)                  = 0

thats above after adding:
CustomLog "| /bin/cat - > /tmp/xx" combined
(normally I use vlogger here; /bin/cat is just for reproduction of the problem)

These kill(0...) seems to be comming from /bin/sh which is run by apache to run /
bin/cat.

After reverting (dropping entire line)
((status = apr_procattr_cmdtype_set(procattr,
                                          APR_SHELLCMD_ENV)) != APR_SUCCESS) 
addition from server/log.c everything is back to normal.


Why apr_procattr...(APR_SHELLCMD_ENV) was added here?
Comment 1 Arkadiusz Miskiewicz 2006-09-11 10:14:01 UTC
Problem caused by commit by trawick:
http://svn.apache.org/viewvc?view=rev&revision=104019
Comment 2 Arkadiusz Miskiewicz 2006-09-11 10:42:17 UTC
The problem is reproducible with pdksh as /bin/sh. I'm unable to reproduce with 
bash as /bin/sh for example.
Comment 3 Jeff Trawick 2006-09-11 13:53:14 UTC
>Why apr_procattr...(APR_SHELLCMD_ENV) was added here?

to correct a regression since Apache 1.3.  Some recipes floating around for
piped loggers for years require that the logging program be started via the shell.

kill(0,...  sends the signal to the whole proccess group.

What is this "service" command?  Do you see any problems using apachectl?
Comment 4 Arkadiusz Miskiewicz 2009-02-17 04:28:55 UTC
service is a shell script that cleans env and runs appropriate init script
(service httpd start is clean env; /etc/rc.d/init.d/httpd start)

I didn't see problems with apachectl because I wasn't using it actually.

I'm using apache with that commit reverted for last almost 3 years now.
Comment 5 William A. Rowe Jr. 2018-11-07 21:09:47 UTC
Please help us to refine our list of open and current defects; this is a mass update of old and inactive Bugzilla reports which reflect user error, already resolved defects, and still-existing defects in httpd.

As repeatedly announced, the Apache HTTP Server Project has discontinued all development and patch review of the 2.2.x series of releases. The final release 2.2.34 was published in July 2017, and no further evaluation of bug reports or security risks will be considered or published for 2.2.x releases. All reports older than 2.4.x have been updated to status RESOLVED/LATER; no further action is expected unless the report still applies to a current version of httpd.

If your report represented a question or confusion about how to use an httpd feature, an unexpected server behavior, problems building or installing httpd, or working with an external component (a third party module, browser etc.) we ask you to start by bringing your question to the User Support and Discussion mailing list, see [https://httpd.apache.org/lists.html#http-users] for details. Include a link to this Bugzilla report for completeness with your question.

If your report was clearly a defect in httpd or a feature request, we ask that you retest using a modern httpd release (2.4.33 or later) released in the past year. If it can be reproduced, please reopen this bug and change the Version field above to the httpd version you have reconfirmed with.

Your help in identifying defects or enhancements still applicable to the current httpd server software release is greatly appreciated.